<div class="container">
	<form [formGroup]="profileForm" class="border p-3 mt-3">

		<h1 class="d-flex justify-content-center">Profile Form</h1>
  		
  		<div class="form-row">
	  		<div class="col pb-3">
				<label>First Name*:</label>
				<input id="firstName" class="form-control" formControlName="firstName" placeholder="First Name">
				
				<div *ngIf="profileFormControl.firstName.invalid && (profileFormControl.firstName.dirty || profileFormControl.firstName.touched)" class="alert alert-warning">
				  	<div *ngIf="profileFormControl.firstName.errors.required">
				    	First Name is required.
				  	</div>
				  	<div *ngIf="profileFormControl.firstName.errors.minlength">
				   	 	First Name must be at least 4 characters long.
				  	</div>
				  	<div *ngIf="profileFormControl.firstName.errors.maxlength">
				   	 	First Name can not be more than 15 characters long.
				  	</div>
				  	<div *ngIf="profileFormControl.firstName.errors.pattern">
				   	 	First Name must be alphabet's only.
				  	</div>
				</div>
			</div>

			<div class="col">	
				<label>Last Name*:</label>
				<input class="form-control" id="lastName" formControlName="lastName" placeholder="Last Name">

				<div *ngIf="profileFormControl.lastName.invalid && (profileFormControl.lastName.dirty || profileFormControl.lastName.touched)" class="alert alert-warning">
				  	<div *ngIf="profileFormControl.lastName.errors.required">
				    	Last Name is required.
				  	</div>
				  	<div *ngIf="profileFormControl.lastName.errors.minlength">
				   	 	Last Name must be at least 4 characters long.
				  	</div>
				  	<div *ngIf="profileFormControl.lastName.errors.maxlength">
				   	 	Last Name can not be more than 15 characters long.
				  	</div>
				  	<div *ngIf="profileFormControl.lastName.errors.pattern">
				   	 	Last Name must be alphabet's only.
				  	</div>
				</div>
			</div>
		</div>
		<div formArrayName="addresses" *ngIf="isAddressPresent">
			<h5 class="d-flex justify-content-center">Address Details</h5>

			<div class="text-right">
				<button type="button" class="btn btn-info" (click)="addNewAddress()">Add Address</button>
			</div>

		    <table class="table table-striped mt-3">
		    	<thead>
		    		<tr>
			    		<th>Street</th>
			    		<th>Zip</th>
			    		<th>City</th>
			    		<th>State</th>
			    		<th>Action</th>
			    	</tr>
		    	</thead>
		    	<tbody>
			    	<tr *ngFor="let row of profileForm.controls.addresses['controls']; let i = index;" [formGroupName] = "i">
			    		<td> {{row.get('street').value}}</td>
			    		<td> {{row.get('zip').value}}</td>
			    		<td> {{row.get('city').value}}</td>
			    		<td> {{row.get('state').value}}</td>
				    	<td>
				    		<button type="button" class="btn btn-secondary" (click)="editAddress(row,i)">Edit</button>
				    		<button type="button" class="btn btn-secondary" (click)="removeAddress(i)">Remove</button>
				    	</td>
				    </tr>
				</tbody>
		    </table>
		</div>

		<app-address *ngIf="showAddressForm" (saveAddress)="addOrUpdateAddress($event)" [data] = "editAddressObj" [actionType]="actionType"></app-address>

		<div class="text-center">
			<button type="submit" class="btn btn-success" [disabled]="!profileForm.valid" (click)="onSubmit()">Submit</button>
		</div>

	</form>

	<div *ngIf="isFormSubmitted" class="border p-3 mt-3">
		<h2 class="d-flex justify-content-center">Profile Details</h2>
		<p><strong>First Name</strong> - {{profileForm.value.firstName }}</p>
		<p><strong>Last Name</strong> - {{profileForm.value.lastName }}</p>
		<div *ngFor="let address of profileForm.get('addresses')['value']; let i = index;">
			<hr class="my-4">
			
			<h5>Address {{i+1}}</h5>	
			<p><strong>Street</strong> - {{address.street }}</p>
			<p><strong>City</strong> - {{address.city }}</p>
			<p><strong>State</strong> - {{address.state }}</p>
			<p><strong>ZIP Code</strong> - {{address.zip }}</p>
		</div>
		
	</div>
</div>
